//
//	 DataPG.cp
//

#define inMetrowerks2
#ifndef inMetrowerks2
typedef unsigned char bool;
#endif

//#define inMacOS
#ifndef inMacOS
#define nil 0L
#endif

#include "DataPG.h"

//#pragma mark -

//
//	TexturePG::TexturePG()
//
//	constructor
//

TexturePG::TexturePG(void)
{
//	for(short i = 0; i < 6; i++)
//		vertices[i] = nil;
	
/*	vertices[0] = new VertexPG(0,0);
	vertices[1] = new VertexPG(15, 0);
	vertices[2] = new VertexPG(15, 15);
	vertices[3] = new VertexPG(0, 15);
*/	
	edgeCount = 0;
	color = 0;
	mode = kInvisable;
	height = 0;
	width = 0;
	
	texture = nil;//new unsigned char[256];
/*	
	unsigned long	index = 0;
	short			i, j, k, m;
	for(i = 0; i < 8; i++)
	{
		for(j = 0; j < 8; j++)
		{
			texture[index] = 150;
			index++;
		}
		for(j = 0; j < 8; j++)
		{
			texture[index] = 200;
			index++;
		}
	}
	
	for(i = 0; i < 8; i++)
	{
		for(j = 0; j < 8; j++)
		{
			texture[index] = 50;
			index++;
		}
		for(j = 0; j < 8; j++)
		{
			texture[index] = 100;
			index++;
		}
	}*/
}

//
//	TexturePG::~TexturePG()
//
//	destructor
//

TexturePG::~TexturePG(void)
{
	if(texture != nil)
		delete [] texture;
}

//
//	TexturePG::AddVertex()
//

void TexturePG::AddVertex(VertexPG* v)
{
	if(edgeCount > 5)
		return;
		
	vertices[edgeCount] = v;
	edgeCount++;
}

//
//	TexturePG::SetColor()
//

void TexturePG::SetColor(unsigned char clr)
{
	color = clr;
}

//
//	TexturePG::SetTexture()
//

void TexturePG::SetTexture(short w, short h)
{
	unsigned long textSize;
	
	textSize = w * h;
	
	if(textSize != 0)
		texture = new unsigned char[textSize];
}

//
//	TexturePG::SetMode()
//

void TexturePG::SetMode(TexturePG::RenderMode drawAs)
{
	mode = drawAs;
}

//#pragma mark -

//
//	TrianglePG::TrianglePG()
//
//	constructor
//

TrianglePG::TrianglePG(void)
{
	vertices[0] = nil;
	vertices[1] = nil;
	vertices[2] = nil;
	vertices[3] = nil;
	vertices[4] = nil;
	texture = nil;
	
	edgeCount = 0;
	clipCount = 0;
}

//
//	TrianglePG::AddVertex()
//

void TrianglePG::AddVertex(VertexPG* vertex)
{
	if(edgeCount < 6)
	{
		vertices[edgeCount] = vertex;
		edgeCount++;
	}
}

//
//	TrianglePG::AddTexture()
//

void TrianglePG::AddTexture(TexturePG* theText)
{
	if(texture == nil)
		texture = theText;
}

//#pragma mark -

//
//	MeshPG::MeshPG()
//
//	constructor
//

MeshPG::MeshPG(void)
{
	origin->x = origin->lx = 0;
	origin->y = origin->ly = 0;
	origin->z = origin->lz = 0;
	
	vertices = nil;
	triangles = nil;
}

//
//	MeshPG::~MeshPG()
//
//	destructor
//

MeshPG::~MeshPG(void)
{
	ClearVertices();
	ClearTriangles();
	ClearTextures();
}

//
//	MeshPG::Morph()
//

void MeshPG::Morph(void)
{
	Entry<VertexPG>*	current = vertices;
	Entry<VertexPG>*	next;
	VertexPG*			vertex;
	
	MorphPG::Morph();
	
	while(current != nil)
	{
		next = current->next;
		vertex = current->content;
		
		Transform(vertex);
		current = next;
	}
}

//
//	MeshPG::ClearVertices()
//

void MeshPG::ClearVertices(void)
{
	Entry<VertexPG>*	current;
	if(vertices == nil)
		return;
		
	current = vertices->LastEntry();
	while(current != nil)
	{
		Entry<VertexPG>*	prior;
		prior = current->prior;
		
		delete current->content;
		delete current;
		current = prior;
	}
}

//
//	MeshPG::ClearTriangles()
//

void MeshPG::ClearTriangles(void)
{
	Entry<TrianglePG>*	current;
	if(triangles == nil)
		return;
		
	current = triangles->LastEntry();
	while(current != nil)
	{
		Entry<TrianglePG>*	prior;
		prior = current->prior;
		
		delete current->content;
		delete current;
		current = prior;
	}
}

//
//	MeshPG::ClearTextures()
//

void MeshPG::ClearTextures(void)
{
	Entry<TexturePG>*	current;
	if(textures == nil)
		return;
		
	current = textures->LastEntry();
	while(current != nil)
	{
		Entry<TexturePG>*	prior;
		prior = current->prior;
		
		delete current->content;
		delete current;
		current = prior;
	}
}

//
//	MeshPG::AddVertex()
//

void MeshPG::AddVertex(VertexPG* item, long id)
{
	Applicant<VertexPG>*		entry;
	entry = new Applicant<VertexPG>(item, id);
	
	if(vertices == nil)
		vertices = entry;
	else
		vertices->AddEntry(entry);
}

//
//	MeshPG::AddTriangle()
//

void MeshPG::AddTriangle(TrianglePG* item, long id)
{
	Applicant<TrianglePG>*		entry;
	entry = new Applicant<TrianglePG>(item, id);
	
	if(triangles == nil)
		triangles = entry;
	else
		triangles->AddEntry(entry);
}

//
//	MeshPG::AddTexture()
//

void MeshPG::AddTexture(TexturePG* item, long id)
{
	Applicant<TexturePG>*		entry;
	entry = new Applicant<TexturePG>(item, id);
	
	if(textures == nil)
		textures = entry;
	else
		textures->AddEntry(entry);
}

//#pragma mark -

//
//	LatticePG::LatticePG()
//
//	constuctor
//

LatticePG::LatticePG(void)
{
	origin->x = 0;	origin->wx = 0;
	origin->y = 0;	origin->wy = 0;
	origin->z = 50;	origin->wz = 50;
	
	meshes = nil;
	
	left = 0;
	top = 0;
	right = 0;
	bottom = 0;
}

//
//	LatticePG::~LatticePG()
//
//	destructor
//

LatticePG::~LatticePG(void)
{
	if(meshes == nil)
		return;
		
	Entry<MeshPG>*	current;
	current = meshes->LastEntry();
	while(current != nil)
	{
		Entry<MeshPG>*	prior;
		prior = current->prior;
		
		delete current->content;
		delete current;
		
		current = prior;
	}
}

//
//	LatticePG::AddMesh()
//

void LatticePG::AddMesh(MeshPG* mesh, char* id)
{
	Frame<MeshPG>*		appli;
	appli = new Frame<MeshPG>(mesh, id);
	mesh->Owner(this);
	
	if(meshes == nil)
		meshes = appli;
	else
		meshes->AddEntry(appli);
}

//
//	LatticePG::RemoveMesh()
//

void LatticePG::RemoveMesh(char* id)
{
	if(meshes == nil)
		return;
		
	Frame<MeshPG>*	entry;
	MeshPG*			mesh;
	
	entry = meshes->Find(id);
	mesh = entry->content;
	
	if(entry == meshes)
		meshes = (Frame<MeshPG>*)entry->next;
		
	delete mesh;
	delete entry;
}

//
//	LatticePG::FindMesh()
//

MeshPG* LatticePG::FindMesh(char* id)
{
	if(meshes == nil)
		return nil;
		
	Frame<MeshPG>*	entry;
	entry = meshes->Find(id);
	
	if(entry == nil)
		return nil;
		
	return entry->content;
}

//
//	LatticePG::LinkMesh()
//

void LatticePG::LinkMesh(char* super, char* sub)
{
	MeshPG*		theSuper;
	MeshPG*		theSub;
	
	theSuper = FindMesh(super);
	theSub = FindMesh(sub);
	if((theSuper == nil) || (theSub == nil))
		return;
		
	theSub->Owner(theSuper);
}

//
//	LatticePG::Morph()
//

void LatticePG::Morph(void)
{
	Entry<MeshPG>*	current;
	Entry<MeshPG>*	next;
	MeshPG*			mesh;
	
	IdentityMatrix(transformMatrix);
	RotateMatrix();
	ScaleMatrix();
	MorphPG::Morph();
	
	current = (Entry<MeshPG>*)meshes;
	while(current != nil)
	{
		next = current->next;
		mesh = current->content;
		
		mesh->Morph();
		current = next;
	}
}

//
//	LatticePG::Bounds()
//
//	finds the on-screen lattice rect
//

void LatticePG::Bounds(void)
{
	left = right = origin->sx;
	top = bottom = origin->sy;
	
	Entry<MeshPG>*	meshi;
	meshi = (Entry<MeshPG>*)meshes;
	
	while(meshi != nil)
	{
		Entry<MeshPG>*	nextMesh;
		MeshPG*			mesh;
		nextMesh = meshi->next;
		mesh = meshi->content;
		
		Entry<TrianglePG>*	current;
		current = (Entry<TrianglePG>*)mesh->triangles;
		
		while(current != nil)
		{
			Entry<TrianglePG>*	next;
			TrianglePG*			tri;
			next = current->next;
			tri = current->content;
			
			for(short i = 0; i < tri->clipCount; i++)
			{
				VertexPG*	vert = &tri->clipped[i];
				
				if(vert->x < left)
					left = vert->x;
				
				if(vert->x > right)
					right = vert->x;
					
				if(vert->y < top)
					top = vert->y;
				
				if(vert->y > bottom)
					bottom = vert->y;
			}
			
			current = next;
		}
		
		meshi = nextMesh;
	}
	left -= 4;
	top -= 4;
	right += 4;
	bottom += 4;
}

//#pragma mark -

//
//	DataPG::DataPG()
//
//	contructor
//

DataPG::DataPG(void)
{
	triangles = nil;
	lattices = nil;
}

//
//	DataPG::~DataPG()
//
//	destructor
//

DataPG::~DataPG(void)
{
	ClearLattices();
	ClearTriangles();
}

//
//	DataPG::ClearLattices()
//

void DataPG::ClearLattices(void)
{
	Entry<LatticePG>*	current;
	current = (Entry<LatticePG>*)lattices;
	
	while(current != nil)
	{
		Entry<LatticePG>*	next;
		next = current->next;
		
		delete current->content;
		delete current;
		
		current = next;
	}
}

//
//	DataPG::ClearTriangles()
//
//	clear the triangle list, but not the
//	triangles themselves. that's done by
//	the mesh destructor
//

void DataPG::ClearTriangles(void)
{
	Entry<TrianglePG>*	current;
	current = triangles;
	while(current != nil)
	{
		Entry<TrianglePG>*	next;
		next = current->next;
		
		delete current;
		current = next;
	}
}

//
//	DataPG::Rotate()
//
//	camera transformation
//

void DataPG::Rotate(short x, short y, short z)
{
	x = -x;
	y = -y;
	z = -z;
	
	MorphPG::Rotate(x, y, z);
}

//
//	DataPG::Scale()
//
//	camera transformation
//

void DataPG::Scale(float x, float y, float z)
{
	//	do nothing because
	//	scaling donsn't apply
	//	to camera transformations
}

//
//	DataPG::Translate()
//
//	camera transformation
//

void DataPG::Translate(short x, short y, short z)
{
	x = -x;
	y = -y;
	z = -z;
	
	MorphPG::Translate(x, y, z);
}

//
//	DataPG::CreateLattice()
//

LatticePG* DataPG::CreateLattice(char* id)
{
	Frame<LatticePG>*		entry;
	LatticePG*			latti;
	
	latti = new LatticePG();
	entry = new Frame<LatticePG>(latti, id);
	latti->Owner(this);
	
	if(lattices == nil)
		lattices = entry;
	else
		lattices->AddEntry(entry);
		
	return latti;
}

//
//	DataPG::DeleteLattice()
//

void DataPG::DeleteLattice(char* id)
{
	LatticePG*	latti;
	latti = FindLattice(id);
	
	Entry<MeshPG>*	mesh = latti->meshes;
	while(mesh != nil)
	{
		Entry<MeshPG>*	nextMesh;
		MeshPG*			theMesh;
		nextMesh = mesh->next;
		theMesh = mesh->content;
		
		Entry<TrianglePG>*	current;
		current = theMesh->triangles;
		while(current != nil)
		{
			Entry<TrianglePG>*	next;
			TrianglePG*			tri;
			next = current->next;
			tri = current->content;
			
			RemoveTriangle(tri);
			current = next;
		}
		
		mesh = nextMesh;
	}
}

//
//	DataPG::FindLattice()
//

LatticePG* DataPG::FindLattice(char* id)
{
	if(lattices == nil)
		return nil;
		
	Frame<LatticePG>*		entry;
	entry = lattices->Find(id);
	
	if(entry == nil)
		return nil;
		
	return entry->content;
}

//
//	DataPG::FindMesh()
//

MeshPG* DataPG::FindMesh(char* lattice, char* mesh)
{
	LatticePG*		latti;
	latti = FindLattice(lattice);
	
	if(latti == nil)
		return nil;
		
	Frame<MeshPG>*	meshList;
	Frame<MeshPG>*	theMesh;
	meshList = latti->meshes;
	
	if(meshList == nil)
		return nil;
		
	theMesh = meshList->Find(mesh);
	return theMesh->content;
}

//
//	DataPG::RegisterTriangle()
//

void DataPG::RegisterTriangle(TrianglePG* tri)
{
	Entry<TrianglePG>*	entry;
	entry = new Entry<TrianglePG>(tri);
	
	if(triangles == nil)
		triangles = entry;
	else
		triangles->AddEntry(entry);
}

//
//	DataPG::RemoveTriangle()
//

void DataPG::RemoveTriangle(TrianglePG* tri)
{
	if(triangles == nil)
		return;
		
	Entry<TrianglePG>*	entry;
	entry = triangles->Find(tri);
	
	if(entry == triangles)
		triangles = triangles->next;
		
	delete entry;
}

//
//	DataPG.cp
//