//
//	FilePG.h
//

#ifndef FILEPG_H
#define FILEPG_H

#include "DataPG.h"
#include <fstream.h>

//
//	FilePG class
//

class FilePG : public DataPG
{
	// member functions
	public:
	
	FilePG();
	~FilePG();
	bool Load(char*);
	
	private:
	
	//	File loader
	void Token(void);
	void End(void);
	
	//	Basic objects
	void FileCreateLattice(void);
	void CreateMesh(void);
	void SetOrigin(void);
	void SetOwner(void);
	void CreateVertex(void);
	void CreateTriangle(void);
	//	texture support
	void CreateTexture(void);
	void SetPoint(void);
	void SetWidth(void);
	void SetHeight(void);
	void SetColor(void);
	void SetMode(void);
	void TexturePrefix(void);
	//	transformations
	void DoRotate(void);
	void DoScale(void);
	void DoTranslate(void);
	
	// data members
	public:
	
	fstream 			*fin;
	char				fLine[80];
	LatticePG*			fLattice;
	MeshPG*				fMesh;
	TexturePG*			fTexture;
};

#endif

//
//	FilePG.h
//