//
//	MorphPG.h
//

#ifndef MORPHPG_H
#define MORPHPG_H

#ifndef _MATH_H_
#include <math.h>
#endif

typedef long	FixedPG;

//
//	VertexPG class
//

class VertexPG
{
	//	member functions
	public:
	
	VertexPG(void);
	VertexPG(short ix, short iy);
	VertexPG(short ix, short iy, short iz);
	
	//	data members
	public:
	
	short	x, y, z;
	short	lx, ly, lz, lt;
	short	tx, ty, tz, tt;
	short 	wx, wy, wz, tw;
	short	sx, sy, st;
};

//
//	MorphPG class
//

class MorphPG
{
	// member functions
	public:
	
	MorphPG(void);
	virtual ~MorphPG(void);
	void Origin(short, short, short);
	void Owner(MorphPG*);
	void Sever(void);
	
	void Rotate(short x, short y, short z);
	void Scale(float x, float y, float z);
	void Translate(short x, short y, short z);
	void Reset(void);
	void Transform(VertexPG*);
	virtual void Morph(void);
	
	void RotateMatrix(void);
	void ScaleMatrix(void);
	FixedPG Sin(short);
	FixedPG Cos(short);
	void IdentityMatrix(FixedPG matrix[4][4]);
	void CopyMatrix(FixedPG sourceMatrix[4][4],
					FixedPG destMatrix[4][4]);
	void MatrixMultiply(	FixedPG matrix1[4][4],
							FixedPG matrix2[4][4],
							FixedPG final[4][4]	);
	
	//	data members
	public:
	
	VertexPG*		origin;
	MorphPG*		owner;
	short			xAngle;
	short			yAngle;
	short			zAngle;
	float			xScale;
	float			yScale;
	float			zScale;
	FixedPG			transformMatrix[4][4];
	FixedPG			sinTable[360];
	FixedPG			cosTable[360];
};

#endif

//
//	MorphPG.h
//