//
//	MapWind.cp
//

#include <Window.h>
#include <View.h>
#include <Bitmap.h>
#include <FilePanel.h>
#include "RenderMap.h"
#include "Mapper.h"

#pragma mark MapWind
#include "MapWind.h"

#pragma mark -

//
//	MapWind::MapWind()
//

MapWind::MapWind(void) : BWindow(BRect(100, 100, 300, 250), 
						"PG Texture Lab", B_TITLED_WINDOW,
						B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{
	BRect	r(0,0,200,10);
	BMenuBar*		menuBar = new BMenuBar(r, "menuBar");
	BMenu*			fileMenu = new BMenu("File");
	BMenu*			textureMenu = new BMenu("Texture");
	BMenu*			modeMenu = new BMenu("Mode");
	
//	fileMenu->AddItem(new BMenuItem("About PGTexLab...", new BMessage(B_ABOUT_REQUESTED)));
//	fileMenu->AddSeparatorItem();
	fileMenu->AddItem(new BMenuItem("Import Graphic...", new BMessage(kImport), 'I', 0));
	fileMenu->AddItem(new BMenuItem("Export Graphic...", new BMessage(kExport), 'E', 0));
	fileMenu->AddSeparatorItem();
	fileMenu->AddItem(new BMenuItem("Quit", new BMessage(B_QUIT_REQUESTED), 'Q', 0));
	
/*	textureMenu->AddItem(new BMenuItem("Select Color...", new BMessage(kColor), 'C', 0));
	textureMenu->AddItem(new BMenuItem("Add texture vertex", new BMessage(kAddVert), 'A', 0));
	
	InvisableItem = new BMenuItem("kInvisable", new BMessage(kInvis));
	WireframeItem = new BMenuItem("kWireframe", new BMessage(kWire));
	PolygonItem = new BMenuItem("kPolygon", new BMessage(kPoly));
	TextureItem = new BMenuItem("kTexture", new BMessage(kText));
	
	InvisableItem->SetMarked(true);
	WireframeItem->SetMarked(false);
	PolygonItem->SetMarked(false);
	TextureItem->SetMarked(false);
	
	modeMenu->AddItem(InvisableItem);
	modeMenu->AddItem(WireframeItem);
	modeMenu->AddItem(PolygonItem);
	modeMenu->AddItem(TextureItem);
*/	
	menuBar->AddItem(fileMenu);
//	menuBar->AddItem(textureMenu);
//	menuBar->AddItem(modeMenu);
	AddChild(menuBar);
	
	textureMenu->SetEnabled(false);
	modeMenu->SetEnabled(false);
	
	openPanel = new BFilePanel(	B_OPEN_PANEL, new BMessenger(this),
								NULL, 0, false, new BMessage(kOpen),
								NULL, false, true	);
	
	savePanel = new BFilePanel(	B_SAVE_PANEL, new BMessenger(this),
								NULL, 0, false, new BMessage(kSave),
								NULL, false, true	);
	
	r = Bounds();
	r.top = menuBar->Frame().bottom + 1;
	mapView = new Mapper(r);
	AddChild(mapView);
	Show();
}

//
//	MapWind::~MapWind()
//
//	destructor
//

MapWind::~MapWind(void)
{
	delete openPanel;
	delete savePanel;
}

//
//	MapWind::MessageReceived()
//

void MapWind::MessageReceived(BMessage* message)
{
	switch(message->what)
	{
		case kImport:
		openPanel->Show();
		break;
		
		case kExport:
		savePanel->Show();
		break;
		
		case kOpen:
		mapView->SetImage(message);
		break;
		
		case kSave:
		mapView->SaveImage(message);
		break;
		
		case kInvis:
		ResetModeMenus();
		InvisableItem->SetMarked(true);
		break;
		
		case kWire:
		ResetModeMenus();
		WireframeItem->SetMarked(true);
		break;
		
		case kPoly:
		ResetModeMenus();
		PolygonItem->SetMarked(true);
		break;
		
		case kText:
		ResetModeMenus();
		TextureItem->SetMarked(true);
		break;
		
		default:
		BWindow::MessageReceived(message);
		break;
	}
}

//
//	MapWind::QuitRequested()
//

bool MapWind::QuitRequested(void)
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}

//
//	MapWind::ResetModeMenus()
//

void MapWind::ResetModeMenus(void)
{
	InvisableItem->SetMarked(false);
	WireframeItem->SetMarked(false);
	PolygonItem->SetMarked(false);
	TextureItem->SetMarked(false);
}

//
//	MapWind.cp
//