//
//	RenderPG.h
//

#ifndef RENDERPG_H
#define RENDERPG_H

//#ifndef DATAPG_H
#include "DataPG.h"
//#endif

//#ifndef FILEPG_H
#include "FilePG.h"
//#endif

//#ifndef _VIEW_H
#include <View.h>
//#endif

//#ifndef _BITMAP_H
#include <Bitmap.h>
//#endif

//
//	RenderPG class
//

class RenderPG : public FilePG, public BView
{
	// member functions
	public:
	
	RenderPG(BRect, char*, BBitmap*);
	~RenderPG(void);
	void Render(void);
	virtual void MessageReceived(BMessage*);
	virtual void Draw(BRect);
	
	// high level ops
	void DrawTriangles(void);
	void RenderTriangle(TrianglePG*);
	void Unimatrix(LatticePG*);
	void ZClip(LatticePG*);
	void Project(LatticePG*);
	void Erase(void);
	
	// support for depth sorting
	protected:
	void Swap(Entry<TrianglePG>*, Entry<TrianglePG>*);
	void Extents(void);
	void ZSort(void);
	void Painters(void);
	bool Backface(TrianglePG*);
	bool ZOverlap(TrianglePG*, TrianglePG*);
	bool XYOverlap(TrianglePG*, TrianglePG*);
	bool Inside(TrianglePG*, TrianglePG*);
	bool Outside(TrianglePG*, TrianglePG*);
	void XYClip(void);
	
	//	drawing functions
	void RenderTriangleWire(TrianglePG*);
	void RenderTrianglePoly(TrianglePG*);
	void RenderTriangleText(TrianglePG*);
	
	// data members
	public:
	
	short					width;
	short					height;
	BBitmap*				frameBuffer;
	long					rowBytes;
	char*					baseAddress;
};

#endif

//
//	RenderPG.h
//