//
//	ViewPG.cp
//

#define inMetrowerks2
#ifndef inMetrowerks2
typedef unsigned char bool;
#endif

//#define inMacOS
#ifndef inMacOS
#define nil 0L
#endif

#include <Application.h>
#include <Path.h>
#include <Bitmap.h>
#include <TranslationUtils.h>
#include <View.h>
#include <OS.h>

#include "PG.h"

//#pragma mark -

//
//	ViewPG::ViewPG()
//
//	constructor
//

ViewPG::ViewPG(BRect rect, char* name)
 : BView(rect, name, B_FOLLOW_NONE, B_WILL_DRAW | B_PULSE_NEEDED)
{
	refreshing = true;
	BRect	r(0, 0, (rect.Width() - 1), (rect.Height() - 1));
	pgBuffer = new BBitmap(r, B_COLOR_8_BIT, true, true);
	frameBuffer = new BBitmap(r, B_RGB_32_BIT, true, true);
	renderer = new RenderPG(r, "RenderPG", pgBuffer);
	frameBuffer->AddChild(renderer);
	
//	view = new BView(rect, "Blanker", B_FOLLOW_NONE, B_WILL_DRAW);
//	pgBuffer->AddChild(view);
	
	refreshing = true;
	background = BTranslationUtils::GetBitmap("ZetaKiosk.jpeg");
	memcpy(frameBuffer->Bits(), background->Bits(), 480*360*4);
	
	//	texting setup
	app_info	daInfo;
	be_app->GetAppInfo(&daInfo);
	BEntry	daEntry(&daInfo.ref);
	daEntry.GetParent(&daEntry);
	BPath	pPath(&daEntry);
	pPath.Append("circumvent.pga");
	char*	path = (char*)pPath.Path();
	renderer->Load("circumvent.pga");
	huh = renderer->FindLattice("Jenn");
//	arm = huh->FindMesh("Arm");
//	fore = huh->FindMesh("Fore");
//	hand = huh->FindMesh("Hand");
//	renderer->Rotate(20,0,0);
//	huh->Scale(2,2,2);
//	renderer->Translate(60,0,0);
}

//
//	ViewPG::~ViewPG()
//
//	destructor
//

ViewPG::~ViewPG(void)
{
//	delete renderer;
//	delete frameBuffer;
}

//
//	ViewPG::MessageReceived()
//

void ViewPG::MessageReceived(BMessage* message)
{
	switch(message->what)
	{
		default:
		BView::MessageReceived(message);
		break;
	}
}

//
//	ViewPG::Draw()
//

void ViewPG::Draw(BRect r)
{
	if(!refreshing)
	{
		if(Window()->Lock() == false)
			return;
		
		DrawBitmap(frameBuffer, BPoint(0,0));		
		Window()->Unlock();
	}
}

//
//	ViewPG::Blank()
//

void ViewPG::Blank(void)
{
	Entry<LatticePG>*	current;
	current = renderer->lattices;
	BRect	rect;
	
	view->SetDrawingMode(B_OP_OVER);
	view->SetHighColor(255, 255, 255);
	while(current != nil)
	{
		Entry<LatticePG>*	next;
		LatticePG*			latti;
		next = current->next;
		latti = current->content;
		
		rect.Set(latti->left, latti->top, latti->right, latti->bottom);
		view->FillRect(rect);
		current = next;
	}
}

//
//	ViewPG::Refresh()
//

void ViewPG::Refresh(void)
{
	Entry<LatticePG>*	current;
	current = renderer->lattices;
	BRect	srcRect;
	BRect	dstRect;
	
	renderer->SetDrawingMode(B_OP_COPY);
	while(current != nil)
	{
		Entry<LatticePG>*	next;
		LatticePG*			latti;
		next = current->next;
		latti = current->content;
		
		srcRect.Set(latti->left, latti->top, latti->right, latti->bottom);
		dstRect = srcRect;
//		dstRect.top -= 1;
//		dstRect.bottom -= 1;
//		dstRect.left += 1;
//		dstRect.right += 1;
		
		renderer->DrawBitmap(background, srcRect, dstRect);
		latti->Bounds();
		current = next;
	}
}

//
//	ViewPG::Render()
//

void ViewPG::Render(void)
{
	Entry<LatticePG>*	current;
	current = renderer->lattices;
	BRect	rect;
	
	renderer->SetDrawingMode(B_OP_OVER);
	while(current != nil)
	{
		Entry<LatticePG>*	next;
		LatticePG*			latti;
		next = current->next;
		latti = current->content;
		
		rect.Set(latti->left, latti->top, latti->right, latti->bottom);
		renderer->DrawBitmap(pgBuffer, rect, rect);
		current = next;
	}
}

//
//	ViewPG::Copy()
//

void ViewPG::Copy(void)
{
	Entry<LatticePG>*	current;
	current = renderer->lattices;
	BRect	rect;
	
	SetDrawingMode(B_OP_COPY);
	while(current != nil)
	{
		Entry<LatticePG>*	next;
		LatticePG*			latti;
		next = current->next;
		latti = current->content;
		
		rect.Set(latti->left, latti->top, latti->right, latti->bottom);
		DrawBitmap(frameBuffer, rect, rect);
		current = next;
	}
}

//
//	ViewPG::AttachedToWindow()
//

void ViewPG::AttachedToWindow(void)
{
	BRect	srcRect = background->Bounds();
	BRect	dstRect = Bounds();
	srcRect.OffsetTo(0,0);
	SetViewBitmap(background, srcRect, srcRect);
	
	thread = spawn_thread(ThreadEntry, "PGAnimate", B_DISPLAY_PRIORITY, this);
	resume_thread(thread);
}

//
//	ViewPG::DetachedFromWindow()
//

void ViewPG::DetachedFromWindow(void)
{
	kill_thread(thread);
}

//
//	ViewPG::ThreadEntry()
//

int32 ViewPG::ThreadEntry(void* ptr)
{
	return ((ViewPG*)ptr)->ThreadProcess();
}

//
//	ViewPG::ThreadProcess()
//

int32 ViewPG::ThreadProcess(void)
{
	while(refreshing)
	{
		if(Window()->Lock())
		{
			huh->Rotate(1,2,1);
//			arm->Rotate(0,1,0);
//			fore->Rotate(0,0,1);
//			hand->Rotate(1,2,1);
			Window()->Unlock();
			
			if(frameBuffer->Lock())
			{
				Refresh();
				if(pgBuffer->Lock())
				{
					renderer->Render();
					renderer->Sync();
					pgBuffer->Unlock();	
				}
				Render();
				frameBuffer->Unlock();
			}
			
			Window()->Lock();
			Copy();
			Window()->Unlock();
		}
	}
	snooze(30000);
	return 0;
}

//
//	ViewPG.cp
//