//
//	ViewPG.h
//

#ifndef VIEWPG_H
#define VIEWPG_H

#ifndef _APPLICATION_H
#include <Application.h>
#endif

#ifndef _PATH_H
#include <Path.h>
#endif

#ifndef _OS_H
#include <OS.h>
#endif

#ifndef _VIEW_H
#include "View.h"
#endif

#ifndef _BITMAP_H
#include "Bitmap.h"
#endif

#ifndef ENTRYPG_H
#include "EntryPG.h"
#endif

#ifndef MORPHPG_H
#include "MorphPG.h"
#endif

#ifndef DATAPG_H
#include "DataPG.h"
#endif

//
//	ViewPG class
//

class ViewPG : public BView
{
	//	member functions
	public:
	
	ViewPG(BRect, char*);
	~ViewPG(void);
	
	virtual void MessageReceived(BMessage*);
	virtual void Draw(BRect);
	
	//	frame drawing
	void Blank(void);
	void Refresh(void);
	void Render(void);
	void Copy(void);
	
	//	thread related functions
	virtual void AttachedToWindow(void);
	virtual void DetachedFromWindow(void);
	static int32 ThreadEntry(void*);
	int32 ThreadProcess(void);
	
	//	data members
	protected:
	
	thread_id				thread;
	volatile bool			refreshing;
	BBitmap*				pgBuffer;
	BBitmap*				frameBuffer;
	BBitmap*				background;
	RenderPG*				renderer;
	BView*					view;
	
	LatticePG*		huh;
	MeshPG*			arm;
	MeshPG*			fore;
	MeshPG*			hand;
};

#endif

//
//	ViewPG.h
//